## CALL_FETCH && Router：

### 1、CALL_FETCH支持特性：

* 跨域（mode: "cors"）
* 请求中types写法支持字符串前缀REPO和[REPO_REQUEST, REPO_SUCCESS, REPO_FAILURE]
* 获取error状态码
* 发送多个并发请求, 返回一个数组[请求1数据,请求2数据]
* 请求可携带标识信息，可在action中拿到该标识信息 (mark: "test")
* 支持自定义header或window函数customHeaders

#### Demo

* 跨域

```
function HandleGetItem() {
  return {
    [CALL_FETCH]: {
        types: REPO,  
        url: 'https://lbs.netease.im/lbs/webconf.jsp?k=02a8065f04ecdbd754d3c6236d244484&id=105557558&sv=24&pv=1',
        method: "GET",
        mode: "cors"    //跨域请求参数
    }
  };
}

//单个异步请求
export function __as_home_getItem() {
  return (dispatch, getState) => {
    return dispatch(HandleGetItem());
  };
}
``` 

* 多个并发请求

```
function HandleMultiAsyn() {
  return {
    [CALL_FETCH]: {
          types: MUTIREPO,
          batch: [{
              url: 'http://localhost:3000/i18nAll/en.js',
              method: "GET",
              mark: "test"
          },{
              url: 'http://localhost:3000/i18nAll/zn.js',
              method: "GET",
              mark: "test"
          },{
              url: 'https://lbs.netease.im/lbs/webconf.jsp?k=02a8065f04ecdbd754d3c6236d244484&id=105557558&sv=24&pv=1',
              method: "GET",
              mark: "test",
              mode: "cors"
          }]
      }
  };
}

//多个并发请求
export function testMultiAsyn() {
  return (dispatch, getState) => {
    return dispatch(HandleMultiAsyn());
  };
}
``` 

### 2、Router支持特性：
* 从store获取router信息，包括key、pathname和query等
* 绑定routerActions，使用push、replace、go、goBack和goForward函数实现页面跳转

#### Demo
* store中获取router信息及绑定routerActions

```
import { routerActions } from 'react-router-redux';

@connect(
  state => ({
      routerInfo: state.routing
  }),
  {...routerActions}
)

test() {
  this.props.go(-1);   //页面跳转
}
```

***Demo演示示例请参考[http://gitlab.beisen.co/next/generator-talentUI]()***