'user strict'

var UnlifyJs = require('uglify-js');
var path = require('path');
var fs = require('fs');


var files =
	[
		"./node_modules/react/dist/react-with-addons.js"
		,"./node_modules/react-dom/dist/react-dom.js"
		,"./node_modules/react-router/umd/ReactRouter.js"
		,"./node_modules/redux/dist/redux.js"
		,"./node_modules/react-redux/dist/react-redux.js"
		,"./node_modules/immutable/dist/immutable.js"
];
var allBuffer = "";

if(process.env.NODE_ENV==='production'){
	var data = fs.readFileSync("./dist/manifest.json", "utf-8");

	data = JSON.parse(data);
	fs.existsSync("./dist")
	var version = data.version;
	var result = UnlifyJs.minify(files,{
    outSourceMap: "out.js.map",
    // sourceRoot: "http://onbook.me",
    mangle:true
	});

	files.push("./dist/talent-libs-"+version+".min.js")

	var buffer = new Buffer(result.code, "utf8");
	fs.writeFileSync("./dist/talent-libs-"+version+".min.js", buffer, 'utf8');

}else if(process.env.NODE_ENV==='development'){
	files.push("./dist/talent-libs.js");
	files.forEach(function(i, item){
		var data = fs.readFileSync(i, "utf-8");
		allBuffer = allBuffer+data;
	});

	fs.writeFile("./dist/talent-libs.js", allBuffer, function(err){
		if(err){
			console.error("make file entry is error "+err);
		}
	})
}