const execSync = require('child_process').execSync;
const exec = require('child_process').exec;

//异步执行命令
function tagSync(cmd) {
  return execSync(cmd).toString();
};

//获取项目最新tag
var lastestTag = tagSync("git describe --tags --abbrev=0").trim();
var last;   //tag最后一个字符

//自动生成新的tag
var makeNewTag = function() {
  //防止ci编译时给tag再加一
  if (lastestTag.indexOf('jenkins') !== -1) {
    lastestTag = tagSync("git describe --tags --match '[0-9]*' --abbrev=0").trim();
    return lastestTag;
  } else {
    if (lastestTag.indexOf('-') !== -1) {
      //测试tag--如0.1.4-1
      last = parseInt(lastestTag.split('-')[1]) + 1;
      lastestTag = lastestTag.split('-')[0] + "-" + last;
    } else {
      var temp = lastestTag.split(".")[lastestTag.split(".").length - 1];
      last = parseInt(temp) + 1;
      lastestTag = lastestTag.substring(0, lastestTag.length - temp.length) + last;
    }
    return lastestTag;
  }
}

module.exports = {
  makeNewTag: makeNewTag
}

