var path = require('path');

module.exports = function(config) {
  config.set({
    basePath: '',
    browsers: [ 'Chrome' ],
    frameworks: ['jasmine'],
    files: [
      'tests/basicTest/*.js'
    ],
    preprocessors: {
      'tests/basicTest/*.js': ['webpack']
    },
    webpack: { //kind of a copy of your webpack config
      module: {
        loaders: [
          {
              test: /\.js$/,
              loader: 'babel',
              exclude: path.resolve(__dirname, 'node_modules')
              // query: {
              //     presets: ['airbnb']
              // }
          },
          {
              test: /\.scss$/,
              loader: "style!css!sass",
              exclude : /node_modules/
          },
          {
              test: /\.json$/,
              loader: 'json'
          }
        ]
      },
      externals: {
        'react/lib/ExecutionEnvironment': true,
        'react/lib/ReactContext': true
      }
    },

    webpackServer: {
      noInfo: true //please don't spam the console when running in karma!
    },

    plugins: [
      'karma-webpack',
      'karma-jasmine',
      'karma-chrome-launcher'
    ],

    // babelPreprocessor: {
    //   options: {
    //       presets: ['airbnb']
    //   }
    // },
    reporters: ['progress'],
    port: 9876,
    colors: true,
    logLevel: config.LOG_INFO,
    autoWatch: true,
    singleRun: false
  })
};
