'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = AnalysisBeforeMiddleware;

var _fetch = require('./fetch');

function AnalysisBeforeMiddleware(store) {
  return function (next) {
    return function (action) {
      //序列化url
      function serialize(obj) {
        var result = [];
        for (var k in obj) {
          result.push(encodeURIComponent(k) + '=' + encodeURIComponent(obj[k]));
        }
        return result.join('&');
      }

      function handleTypes(types) {
        if (Array.isArray(types) && types.length == 3) {
          var last = types[0].lastIndexOf("_");
          return last ? types[0].slice(0, last) : "";
        } else if (typeof types === 'string') {
          return types;
        }
      }

      function handleParam(_requestType, url, method, params) {
        if (method == "GET" && params) {
          url = url + "?" + serialize(params);
        }
        //url加域名
        if (url && url.indexOf('http') === -1) {
          url = location.protocol + "//" + location.host + url;
        }
        window.iTalentPMS && window.iTalentPMS.addAjax && window.iTalentPMS.addAjax(_requestType, 'start', url, method);
      }

      var callFETCH = action[_fetch.CALL_FETCH];
      var type = action.type;

      if (typeof callFETCH === 'undefined' && type) {
        window.iTalentPMS && window.iTalentPMS.addAction && window.iTalentPMS.addAction(type, 'start');
      } else if (callFETCH && callFETCH.batch) {
        //针对多个并发接口的打点
        var batch = callFETCH.batch,
            types = callFETCH.types;

        var _requestType = handleTypes(types);

        for (var i = 0; i < batch.length; i++) {
          var _batch$i = batch[i],
              url = _batch$i.url,
              method = _batch$i.method,
              params = _batch$i.params;

          handleParam(_requestType, url, method, params);
        }
        window.iTalentPMS && window.iTalentPMS.addAction && window.iTalentPMS.addAction(_requestType, 'start');
      } else {
        //针对单个请求的打点
        var url = callFETCH.url,
            method = callFETCH.method,
            params = callFETCH.params,
            _types = callFETCH.types;

        var _requestType2 = handleTypes(_types);
        handleParam(_requestType2, url, method, params);
        window.iTalentPMS && window.iTalentPMS.addAction && window.iTalentPMS.addAction(_requestType2, 'start');
      }
      return next(action);
    };
  };
} /**
   * Created by huijuan on 15/8/31.
   */
//截取特定action用于统计分析
module.exports = exports['default'];