'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CALL_FETCH = undefined;

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _iterator2 = require('babel-runtime/core-js/symbol/iterator');

var _iterator3 = _interopRequireDefault(_iterator2);

var _symbol = require('babel-runtime/core-js/symbol');

var _symbol2 = _interopRequireDefault(_symbol);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _es6Promise = require('es6-promise');

require('isomorphic-fetch');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Created by liuhuijuan on 15/8/31.
 */
var URLSearchParams = require('url-search-params');

//序列化url
function serialize(obj) {
  var result = [];
  for (var k in obj) {
    result.push(encodeURIComponent(k) + '=' + encodeURIComponent(obj[k]));
  }
  return result.join('&');
}
//判断是否数组
function isArray(obj) {
  return Object.prototype.toString.call(obj) === '[object Array]';
}

//判断是否为对象
function isObj(obj) {
  return Object.prototype.toString.call(obj) === '[object Object]';
}

//判断是否为空对象
function isEmptyObject(obj) {
  for (var key in obj) {
    return false;
  };
  return true;
};

//请求接口
function callFetch(url, method, params, headers, mode, dataType, mark) {
  var fullUrl = url;
  var data = {};
  var defaultHeaders = {
    'Accept': 'application/json, application/xml, text/play, text/html, *.*',
    'Content-Type': 'application/json; charset=utf-8'
  };

  if (method.toUpperCase() == "GET" && params) {
    var conParam = fullUrl.indexOf("?") != -1 ? '&' : '?';
    fullUrl = fullUrl + conParam + serialize(params) + '&time=' + new Date().valueOf(); //拼接get请求
  } else if (headers && headers['Content-Type'] == 'application/x-www-form-urlencoded') {
    var urlSear = new URLSearchParams();
    for (var i in params) {
      urlSear.append(i, params[i]);
    }
    data.body = urlSear.toString();
    data.method = method;
  } else {
    data.body = (0, _stringify2.default)(params);
    data.method = method;
  }
  //统一给url上新增参数：get和post请求
  var shadowContextStr = sessionStorage.getItem('shadow_context');
  var _pt = sessionStorage.getItem('_pt');
  var _ptid = sessionStorage.getItem('_ptid');

  var isWinParam = false;
  if (window.customParam && isObj(window.customParam) && !isEmptyObject(window.customParam)) {
    var joinParam = fullUrl.indexOf("?") != -1 ? '&' : '?';
    fullUrl = fullUrl + joinParam + serialize(window.customParam);
    isWinParam = true;
  }

  if (!isWinParam && shadowContextStr) {
    var joinShadow = fullUrl.indexOf("?") != -1 ? '&' : '?';
    fullUrl = fullUrl + joinShadow + 'shadow_context=' + shadowContextStr;
  }
  if (!isWinParam && _pt && _ptid) {
    var joinPt = fullUrl.indexOf("?") != -1 ? '&' : '?';
    fullUrl = fullUrl + joinPt + '_pt=' + _pt + '&_ptid=' + _ptid;
  }

  var newHeaders;
  if (window.customHeaders && typeof window.customHeaders == 'function') {
    newHeaders = (0, _assign2.default)({}, defaultHeaders, window.customHeaders());
  } else {
    newHeaders = (0, _assign2.default)({}, defaultHeaders, headers);
  }
  data.headers = newHeaders;
  data.credentials = 'include'; //传递cookie信息
  // data.mode = mode || null;

  //兼容safari url编码
  if (navigator.userAgent.indexOf("Safari") != -1 && navigator.userAgent.indexOf("Chrome") == -1) {
    fullUrl = fullUrl.replace(/%25/g, '%');
  }

  if (dataType && dataType == 'text') {
    return fetch(fullUrl, data).then(function (response) {
      return response.text().then(function (json) {
        if (!response.ok) {
          return _promise2.default.reject({ status: response.status, json: json });
        }
        return { status: response.status };
      });
    });
  }

  return fetch(fullUrl, data).then(function (response) {

    if (!response.ok) {
      response.json = function () {
        return this.text().then(function (data) {
          try {
            return JSON.parse(data);
          } catch (e) {
            return _promise2.default.reject(response);
          }
        });
      };
    }

    return response.json().then(function (json) {
      return { json: json, response: response };
    });
  }).then(function (_ref) {
    var json = _ref.json,
        response = _ref.response;


    if (!response.ok) {
      return _promise2.default.reject({ json: json, response: response });
    }

    if (isArray(json)) {
      return json.slice();
    } else {
      return (0, _assign2.default)({}, json);
    }
  });
}

//CALL_FETCH  无实际意义 防止用户写错
var CALL_FETCH = exports.CALL_FETCH = (0, _symbol2.default)('call API');

exports.default = function () {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return function (store) {
    return function (next) {
      return function (action) {
        var callFETCH = action[CALL_FETCH];

        if (typeof callFETCH === 'undefined') {
          return next(action);
        }

        var batch = callFETCH.batch,
            types = callFETCH.types;

        var nextActions = void 0;
        var batchArr = [];

        var dispatch = store.dispatch;
        var requestType = void 0,
            successType = void 0,
            failureType = void 0;

        if (Array.isArray(types) && types.length == 3) {
          requestType = types[0];
          successType = types[1];
          failureType = types[2];
        } else if (typeof types === 'string') {
          requestType = types + '_REQUEST';
          successType = types + '_SUCCESS';
          failureType = types + '_FAILURE';
        } else {
          throw new Error('Expected action types to be strings.');
        }

        function actionWith(data) {
          var finalAction = (0, _assign2.default)({}, action, data);
          delete finalAction[CALL_FETCH];
          return finalAction;
        }

        next(actionWith({ type: requestType }));

        if (batch) {
          nextActions = batch.nextActions || undefined;

          if (!(batch && (typeof batch[_iterator3.default] === 'function' || Array.isArray(batch)))) {
            throw new TypeError('Expected batch to be iterable, got ' + _inspect(batch));
          }

          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = (0, _getIterator3.default)(batch), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var unity = _step.value;
              var url = unity.url,
                  method = unity.method;
              var params = unity.params,
                  headers = unity.headers,
                  mode = unity.mode,
                  dataType = unity.dataType,
                  mark = unity.mark;

              method = method || "POST";

              if (typeof url === 'function') {
                url = url(store.getState());
              }
              if (typeof url !== 'string') {
                throw new Error('Specify a string endpoint URL.');
              }
              batchArr.push(callFetch(url, method, params, headers, mode, dataType, mark));
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }

          return _promise2.default.all(batchArr).then(function (response) {
            if (nextActions) fireNextAction(nextActions, dispatch, response);
            if (!isArray(response)) response = [];

            next(actionWith({
              response: response,
              type: successType,
              batch: batch,
              payload: 'Injection'
            }));
          }, function (error) {
            if (error.response) {
              var errorData = error.response;
              for (var key in error.json) {
                errorData[key] = error.json[key];
              }
            } else {
              var errorData = error;
            }
            next(actionWith({
              type: failureType,
              error: errorData,
              payload: 'Injection'
            }));
          });
        } else {
          var _ret = function () {
            nextActions = callFETCH.nextActions || undefined;
            var url = callFETCH.url,
                params = callFETCH.params,
                method = callFETCH.method,
                headers = callFETCH.headers,
                mode = callFETCH.mode,
                dataType = callFETCH.dataType,
                mark = callFETCH.mark;

            return {
              v: callFetch(url, method, params, headers, mode, dataType, mark).then(function (response) {
                if (nextActions) fireNextAction(nextActions, dispatch, response);
                next(actionWith({
                  response: response,
                  type: successType,
                  url: url,
                  params: params,
                  method: method,
                  mark: mark,
                  payload: 'Injection'
                }));
              }, function (error) {
                if (error.response) {
                  var errorData = error.response;
                  for (var key in error.json) {
                    errorData[key] = error.json[key];
                  }
                } else {
                  var errorData = error;
                }

                next(actionWith({
                  type: failureType,
                  error: errorData,
                  payload: 'Injection'
                }));

                return next(actionWith({
                  type: "PROCESS_HTTP_CODE",
                  error: errorData
                }));
              })
            };
          }();

          if ((typeof _ret === 'undefined' ? 'undefined' : (0, _typeof3.default)(_ret)) === "object") return _ret.v;
        }
      };
    };
  };
};

//执行下一个action,并将数据传递给它


function fireNextAction(nextActions, dispatch, response) {
  if (nextActions && nextActions.length > 0 && dispatch) {
    nextActions.map(function (action, index, arr) {
      action({ data: response });
    });
  }
}

function _inspect(input, depth) {
  var maxDepth = 4;
  var maxKeys = 15;

  if (depth === undefined) {
    depth = 0;
  }

  depth += 1;

  if (input === null) {
    return 'null';
  } else if (input === undefined) {
    return 'void';
  } else if (typeof input === 'string' || typeof input === 'number' || typeof input === 'boolean') {
    return typeof input === 'undefined' ? 'undefined' : (0, _typeof3.default)(input);
  } else if (Array.isArray(input)) {
    if (input.length > 0) {
      var _ret2 = function () {
        if (depth > maxDepth) return {
            v: '[...]'
          };

        var first = _inspect(input[0], depth);

        if (input.every(function (item) {
          return _inspect(item, depth) === first;
        })) {
          return {
            v: first.trim() + '[]'
          };
        } else {
          return {
            v: '[' + input.slice(0, maxKeys).map(function (item) {
              return _inspect(item, depth);
            }).join(', ') + (input.length >= maxKeys ? ', ...' : '') + ']'
          };
        }
      }();

      if ((typeof _ret2 === 'undefined' ? 'undefined' : (0, _typeof3.default)(_ret2)) === "object") return _ret2.v;
    } else {
      return 'Array';
    }
  } else {
    var keys = (0, _keys2.default)(input);

    if (!keys.length) {
      if (input.constructor && input.constructor.name && input.constructor.name !== 'Object') {
        return input.constructor.name;
      } else {
        return 'Object';
      }
    }

    if (depth > maxDepth) return '{...}';
    var indent = '  '.repeat(depth - 1);
    var entries = keys.slice(0, maxKeys).map(function (key) {
      return (/^([A-Z_$][A-Z0-9_$]*)$/i.test(key) ? key : (0, _stringify2.default)(key)) + ': ' + _inspect(input[key], depth) + ';';
    }).join('\n  ' + indent);

    if (keys.length >= maxKeys) {
      entries += '\n  ' + indent + '...';
    }

    if (input.constructor && input.constructor.name && input.constructor.name !== 'Object') {
      return input.constructor.name + ' {\n  ' + indent + entries + '\n' + indent + '}';
    } else {
      return '{\n  ' + indent + entries + '\n' + indent + '}';
    }
  }
}