'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

exports.default = ConfigureStore;

var _redux = require('redux');

var _reduxThunk = require('redux-thunk');

var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

var _reduxLogger = require('redux-logger');

var _reduxLogger2 = _interopRequireDefault(_reduxLogger);

var _fetch = require('./../middleware/fetch');

var _fetch2 = _interopRequireDefault(_fetch);

var _analysisBefore = require('./../middleware/analysisBefore');

var _analysisBefore2 = _interopRequireDefault(_analysisBefore);

var _analysisAfter = require('./../middleware/analysisAfter');

var _analysisAfter2 = _interopRequireDefault(_analysisAfter);

var _reduxPromiseMiddleware = require('redux-promise-middleware');

var _reduxPromiseMiddleware2 = _interopRequireDefault(_reduxPromiseMiddleware);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//创建日志
var loggerMiddleware = (0, _reduxLogger2.default)({
  level: 'info',
  collapsed: true,
  predicate: function predicate(getState, action) {
    return __DEVELOPMENT__;
  }
});
//判断是否为对象
/**
 * Created by liubo on 15/8/31.
 */
function isObj(obj) {
  return Object.prototype.toString.call(obj) === '[object Object]';
}
// Creates a preconfigured store for this example.
function ConfigureStore(reducers, middleware, initialState) {
  var reducer = void 0;
  if (isObj(reducers)) {
    reducer = (0, _redux.combineReducers)(reducers);
  } else if (typeof reducers === 'function') {
    reducer = reducers;
  } else {
    throw new Error('Make sure the type of reducers is object or function.');
  }
  var customMiddleware = [_reduxThunk2.default, _analysisBefore2.default, (0, _reduxPromiseMiddleware2.default)({
    promiseTypeSuffixes: ['REQUEST', 'SUCCESS', 'FAILURE']
  }), (0, _fetch2.default)(), _analysisAfter2.default, loggerMiddleware].concat((0, _toConsumableArray3.default)(middleware));
  //添加中间件
  var createStoreWithMiddleware = _redux.applyMiddleware.apply(undefined, (0, _toConsumableArray3.default)(customMiddleware))(_redux.createStore);
  return createStoreWithMiddleware(reducer, initialState);
}
module.exports = exports['default'];