'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = CreateEntry;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactRouter = require('react-router');

var _reactRedux = require('react-redux');

var _configureStore = require('./configureStore');

var _configureStore2 = _interopRequireDefault(_configureStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//创建程序入口

//加载react-redux
function CreateEntry(param) {
    var entry = {
        $el: param.$el || document.getElementById('bs-main'),
        reducers: param.reducers,
        routes: param.routes,
        middleware: param.middleware || []
    };
    var store = (0, _configureStore2.default)(entry.reducers, entry.middleware);
    //结合saga兼容代码
    var midd = entry.middleware;
    midd.map(function (item) {
        if (item.name === 'sagaMiddleware' && param.actions) {
            item.run(param.actions);
        }
    });
    //渲染到指定元素
    _reactDom2.default.render(_react2.default.createElement(
        _reactRedux.Provider,
        { store: store },
        _react2.default.createElement(_reactRouter.Router, {
            routes: entry.routes,
            history: _reactRouter.hashHistory })
    ), entry.$el);
    return store;
}
//加载history
/**
 * Created by liubo on 16/1/25.
 */
module.exports = exports['default'];