
// 已经下载过的模块
var installedModules = {};

var getModuleUrl = function(moduleName, version) {
	return [ '//stnew03.beisen.com/ux/p-beisen-components/', moduleName, '-', version, '.js' ].join('')
}


var requireModule = function(src, callback) {
	var script = document.createElement('script');

	script.src = src;
	script.async = false; // 脚本必须按序执行，异步模块中有 currentScript 的兼容逻辑	
	script.type = "text/javascript";
	// script.setAttribute('crossorigin', 'anonymous'); // 不同域异常信息的抓取
    
    script.addEventListener('export', function (moduleOnExportCusEvent) {
    	// 通过事件传递的对象要放在 detail 里
    	callback(moduleOnExportCusEvent.detail);
    	script.remove();
    }, false);

    // todo IE浏览器的 时间注册兼容

    // 为了确保在异步加载的模块中的context对象正确
    // 要确保添加script时, 每次都放在head里的最后一个位置
	document.getElementsByTagName('head')[0].appendChild(script);
}


var syncImport = function(opts) {

	// var moduleName = opts.moduleName
		// , version = opts.version;

	// make module's uri
	var moduleSrc = 'async-module.js';

	// Check if module is in cache
	if(installedModules[ moduleSrc ]) {
		return installedModules[ moduleSrc ].exports;
	}

	// Create a new module (and put it into the cache)
	var module = installedModules[ moduleSrc ] = {
		exports: {},
		loaded: false
	};

	// 异步请求模块
	requireModule(moduleSrc, function callback(moduleExports){
		module.loaded = true;
		module.exports = moduleExports;
	});

	// Return the exports of the module
	return module.exports;
}

var asyncRequire = function(deps, callback) {

}

