import { compose} from 'redux'
import { shallow, mount, render } from 'enzyme';

describe('compose',function(){
	it('composees from right to left',function(){
		const double = x => x*2
		const square = x => x*x

		expect(compose(square)(5)).toBe(25)
		expect(compose(square,double)(5)).toBe(100)
		expect(compose(double,square,double)(5)).toBe(200)
	})
	it('composes functions from right to left',function(){
		
		const a = next =>x => next(x + 'a')
		const b = next =>x =>next(x+'b')
		const c = next=>x =>next(x+'c')

		const final = x =>x

		expect(compose(a,b,c)(final)('cba'))
		expect(compose(c,b,a)(final)('abc'))
		expect(compose(c,a,b)(final)('bac'))
	})

	it('returns the first given argument if given no functions',function(){

		expect(compose()(1,2)).toBe(1)
		expect(compose()(3)).toBe(3)
		expect(compose()()).toBe(undefined)
	})
})