import React, {Component, PropTypes} from 'react'
import { shallow, mount, render } from 'enzyme';

//shallow 就是官方的shallow rendering 封装
//render 将react 组件渲染成静态的HTML字符串,然后分析这段HTML代码的结构，返回一个对象
//mount 方法用于将React 组件加载为真实的DOM节点

class MyComponent extends Component{
  componentDidMount (){

  }
  componentWillMount (){

  }

  componentWillUpdate(){

  }
  componentDidUpdate(){
    
  }
  componentWillReceiveProps(){

  }
  componentWillUnmount (){

  }
  render(){
    return (
      <div className={this.props.foo}></div>
    );
  }
}

describe('test life cycle',function(){
	it('test 6 function',function(){

    spyOn(MyComponent.prototype,'componentDidMount');
    spyOn(MyComponent.prototype,'componentWillMount');
    spyOn(MyComponent.prototype,'componentWillUpdate');
    spyOn(MyComponent.prototype,'componentDidUpdate');
    spyOn(MyComponent.prototype,'componentWillReceiveProps');
    spyOn(MyComponent.prototype,'componentWillUnmount');
    //spyOn(MyComponent.prototype,'shouldComponentUpdate');

    const wrapper = mount(<MyComponent foo="bar" />);
    
    expect(MyComponent.prototype.componentWillMount).toHaveBeenCalledTimes(1);
    expect(MyComponent.prototype.componentDidMount).toHaveBeenCalledTimes(1);
    
    expect(MyComponent.prototype.componentWillReceiveProps).toBeDefined();
    expect(MyComponent.prototype.componentWillUnmount).toBeDefined();
    //expect(MyComponent.prototype.shouldComponentUpdate).toBeDefined();
    expect(MyComponent.prototype.componentWillUpdate).toBeDefined;

    wrapper.setProps({foo:'foo'});

    expect(MyComponent.prototype.componentWillMount).toHaveBeenCalledTimes(1);
    expect(MyComponent.prototype.componentDidMount).toHaveBeenCalledTimes(1);
    expect(MyComponent.prototype.componentWillReceiveProps).toHaveBeenCalledTimes(1);
    expect(MyComponent.prototype.componentWillUpdate).toHaveBeenCalled;//更新之前
    expect(MyComponent.prototype.componentDidUpdate).toHaveBeenCalled; //更新之前

    expect(MyComponent.prototype.componentWillUnmount).toBeDefined;

    wrapper.unmount();
    expect(MyComponent.prototype.componentWillUnmount).toHaveBeenCalledTimes(1);


	})
});