const ADD_TODO = 'ADD_TODO'
const DISPATCH_IN_MIDDLE = 'DISPATCH_IN_MIDDLE'
const THROW_ERROR = 'THROW_ERROR'
const UNKNOWN_ACTION = 'UNKNOWN_ACTION'

function id(state = []){
	return state.reduce((result,item) =>(item.id > result ? item.id : result),0) + 1;
}

export function todos(state = [],action){
	switch(action.type){
		case ADD_TODO : 
			return [
				...state,{
					id : id(state),
					text : action.text
				}
			];
		default : 
			return state
	}
}

export function todosReverse(state=[],action){
	switch(action.type){
		case ADD_TODO : 
			return [
				{
					id : id(state),
					text : action.text
				},...state
			]
		default : 
			return state;
	}
}

export function dispatchInTheMiddleOfReducer(state = [],action){
	switch(action.type){
		case DISPATCH_IN_MIDDLE : 
			action.boundDispatchFn();
			return state
		default : 
			return state
	}
}

export function errorThrowingReducer(state=[],action){
	switch(action.type){
		case THROW_ERROR : 
			throw new Error()
		default:
			return state;
	}
}


export function addToDo(text){
	return {type:ADD_TODO,text}
}

/*export function addToDoAsync(text){
	return dispatch => new Promise(resolve => setImmediate(() =>{
		dispatch(addToDo(text))
		resolve()
	}))
}*/

export function addToDoIfEmpty(text){
	return (dispatch,getState) =>{
		if(!getState().length){
			dispatch(addToDo(text))
		}
	}
}

export function dispatchInMiddle(boundDispatchFn){
	return {
		type : DISPATCH_IN_MIDDLE,
		boundDispatchFn
	}
}

export function throwError(){
	return {
		type : THROW_ERROR
	}
}

export function unknowAction(){
	return {
		type : UNKNOWN_ACTION
	}
}